# ESB iRule to change the destination VIP and URI based on source URI
# https://devcentral.f5.com/articles/irules-101-04-switch
# https://devcentral.f5.com/s/question/0D51T00006i7de9SAA/http-rewrite-header-pool-based-on-uri
#
when HTTP_REQUEST { 
  # Get Packet UUID info if any
  set uuid "None"
  set packet_uuid [HTTP::header values uniqueid]
  set packet_uuid_len [string length $packet_uuid]
  if { $packet_uuid_len > 0 } {
     set uuid [HTTP::header values uniqueid]
  }

  # Get and Set X-Forwarded-For Info
  set xfwd [IP::client_addr]
  set packet_sfwd [HTTP::header X-Forwarded-For]
  set packet_sfwd_len [string length $packet_sfwd]
  if { $packet_sfwd_len > 0 } {
     # If X-Forwarded-For exists Put it into a variable for logging
     set xfwd [HTTP::header X-Forwarded-For]
  } else {
     # X-Forwarded-For doesn't exist so add it to the HTTP Header
     HTTP::header insert X-Forwarded-For [IP::client_addr]
  }

  # Connection is allways HTTP and VIP
  # Never has serverssl enabled.  Seperate iRule for SSL VIP 
  #set http_or_https [TCP::local_port clientside]
  set new_vip_1 "esbtest.genpt.com_vip_80"
  #if {$http_or_https == 80 } {
  #   # Make the Variable be the HTTP VIP
  #   set new_vip_1 "esbtest.genpt.com_vip_80"
  #} elseif { $http_or_https == 443 } {
  #   # Make the Variable be the HTTPS VIP
  #   set new_vip_1 "esbtest.genpt.com_vip_443"
  #}

  # Match the URI then re-write accordingly
  set legacy_hostname "devgateway.napaprolink.com"
  set new_hostname_1 "esbtest.genpt.com"
  # Get Initial Info before modifications
  set request_host [HTTP::host]
  set request_uri [HTTP::uri] 
  switch -glob [HTTP::uri] {
    #"/b2bBridge3" {
    ## If URI Matched then re-write the host/FQDN and possibly the URI
    #  HTTP::header replace Host $new_hostname_1
    #  HTTP::uri "/b2bAswaRouter"
    #  virtual $new_vip_1
    #  set myvip $new_vip_1
    #  set LogString "VIP:[virtual name], HTTP_REQUEST, UUID:$uuid, Client IP:[IP::client_addr], Real Client IP $xfwd:[TCP::client_port], Requested URL $request_host$request_uri, Sent URL [HTTP::host][HTTP::uri], VIP $myvip"
    #}
    #"/b2bBridge2" -
    #"/TamsService" -
    #"/TamsService2" -
    #"/b2bBridgeSDK" -
    #"/b2bBridgetest" -
    #"/tamsSimulator" -
    #"/b2bBridgeRouter" {
    ## If URI Matched then re-write the host/FQDN and possibly the URI
    #  HTTP::header replace Host $new_hostname_1
    #  HTTP::uri "/b2bBridgeRouter"
    #  virtual $new_vip_1
    #  set myvip $new_vip_1
    #  set LogString "VIP:[virtual name], HTTP_REQUEST, UUID:$uuid, Client IP:[IP::client_addr], Real Client IP $xfwd:[TCP::client_port], Requested URL $request_host$request_uri, Sent URL [HTTP::host][HTTP::uri], VIP $myvip"
    #}
    #"/findItGate" {
    ## If URI Matched then re-write the host/FQDN and possibly the URI
    #  HTTP::header replace Host $new_hostname_1
    #  HTTP::uri "/b2bFindItRouter"
    #  virtual $new_vip_1
    #  set myvip $new_vip_1
    #  set LogString "VIP:[virtual name], HTTP_REQUEST, UUID:$uuid, Client IP:[IP::client_addr], Real Client IP $xfwd:[TCP::client_port], Requested URL $request_host$request_uri, Sent URL [HTTP::host][HTTP::uri], VIP $myvip"
    #}
    #"/ISSC" -
    #"/ISSCtest" {
    ## If URI Matched then re-write the host/FQDN and possibly the URI
    #  HTTP::header replace Host $new_hostname_1
    #  HTTP::uri "/b2bIsscRouter"
    #  virtual $new_vip_1
    #  set myvip $new_vip_1
    #  set LogString "VIP:[virtual name], HTTP_REQUEST, UUID:$uuid, Client IP:[IP::client_addr], Real Client IP $xfwd:[TCP::client_port], Requested URL $request_host$request_uri, Sent URL [HTTP::host][HTTP::uri], VIP $myvip"
    #}
    #"/multiStoreGate" {
    ## If URI Matched then re-write the host/FQDN and possibly the URI
    #  HTTP::header replace Host $new_hostname_1
    #  HTTP::uri "/b2bMultiStoreRouter"
    #  virtual $new_vip_1
    #  set myvip $new_vip_1
    #  set LogString "VIP:[virtual name], HTTP_REQUEST, UUID:$uuid, Client IP:[IP::client_addr], Real Client IP $xfwd:[TCP::client_port], Requested URL $request_host$request_uri, Sent URL [HTTP::host][HTTP::uri], VIP $myvip"
    #}
    #"/b2bBridgeProlink" -
    #"/b2bBridge" -
    #"/prolinkSimulator" {
    ## If URI Matched then re-write the host/FQDN and possibly the URI
    #  HTTP::header replace Host $new_hostname_1
    #  HTTP::uri "/b2bProlinkRouter"
    #  virtual $new_vip_1
    #  set myvip $new_vip_1
    #  set LogString "VIP:[virtual name], HTTP_REQUEST, UUID:$uuid, Client IP:[IP::client_addr], Real Client IP $xfwd:[TCP::client_port], Requested URL $request_host$request_uri, Sent URL [HTTP::host][HTTP::uri], VIP $myvip"
    #}
    #"/secureb2bBridge" -
    #"/secureb2bBridgetest" {
    ## If URI Matched then re-write the host/FQDN and possibly the URI
    #  HTTP::header replace Host $new_hostname_1
    #  HTTP::uri "/b2bSecureRouter"
    #  virtual $new_vip_1
    #  set myvip $new_vip_1
    #  set LogString "VIP:[virtual name], HTTP_REQUEST, UUID:$uuid, Client IP:[IP::client_addr], Real Client IP $xfwd:[TCP::client_port], Requested URL $request_host$request_uri, Sent URL [HTTP::host][HTTP::uri], VIP $myvip"
    #}
    "/fastreggate*" -
    "/fastreggate2*" {
    # If URI Matched then re-write the host/FQDN and possibly the URI
      HTTP::header replace Host $new_hostname_1
      HTTP::uri "/prolinkregistration"
      virtual $new_vip_1
      set myvip $new_vip_1
      set LogString "VIP:[virtual name], HTTP_REQUEST, UUID:$uuid, Client IP:[IP::client_addr], Real Client IP $xfwd:[TCP::client_port], Requested URL $request_host$request_uri, Sent URL [HTTP::host][HTTP::uri], VIP $myvip"
    }    
    "/rb/*" {
    # If URI Matched then strip "/rb" from URI
      set original_uri [HTTP::uri]
      set rb_uri [string trimleft $original_uri /]
      set rb_uri [string trimleft $rb_uri rb]
      HTTP::uri $rb_uri
      pool "devgateway.napaprolink.com_pool_80"
      set mypool "devgateway.napaprolink.com_pool_80"    
      set LogString "VIP:[virtual name], HTTP_REQUEST, UUID:$uuid, Client IP:[IP::client_addr], Real Client IP $xfwd:[TCP::client_port], Requested URL $request_host$request_uri, Sent URL [HTTP::host][HTTP::uri], Pool $mypool"
    }
    "/b2bplus*" - 
    "/consignmentGate*" -
    "/consignGateTest*" -
    "/rpmGateway*" -
    "/rpmGatewaytest*" -
    "/*" {
    # Default Match All for VIP - Do not re-write these matches
      pool "devgateway.napaprolink.com_pool_80"
      set mypool "devgateway.napaprolink.com_pool_80"    
      set LogString "VIP:[virtual name], HTTP_REQUEST, UUID:$uuid, Client IP:[IP::client_addr], Real Client IP $xfwd:[TCP::client_port], Requested URL [HTTP::host][HTTP::uri], Sent URL [HTTP::host][HTTP::uri], Pool $mypool"
    }
  }
}
when LB_SELECTED {
      # Create Variable to Log Pool Member Chosen
      set LogString2 "to Pool Mbr [LB::server addr]"
      # Log Client IP, URL, and Pool Member Chosen
      log local0. "$LogString $LogString2"
}
when HTTP_RESPONSE {
  set uuid "None"
  set packet_uuid [HTTP::header values uniqueid]
  set packet_uuid_len [string length $packet_uuid]
  if { $packet_uuid_len > 0 } {
     set uuid [HTTP::header values uniqueid]
  }

  # Collect data in the Response packet_sfwd
  set reply_host [HTTP::header host]
  set reply_uri [HTTP::header uri] 

  log local0. "VIP:[virtual name], HTTP_RESPONSE, UUID:$uuid, HTTP Code:[HTTP::status], Pool Member:[LB::server addr], Pool Member URL $reply_host$reply_uri, Reply URI [HTTP::header host][HTTP::header uri] , Client IP:[IP::client_addr]:[TCP::client_port]"
}
