# ESB iRule to set correct pool based on URI
# https://devcentral.f5.com/articles/irules-101-04-switch
#
when HTTP_REQUEST { 
  set uuid "None"
  set packet_uuid [HTTP::header values uniqueid]
  set packet_uuid_len [string length $packet_uuid]
  if { $packet_uuid_len > 0 } {
     set uuid [HTTP::header values uniqueid]
  }
  set xfwd [IP::client_addr]
  set packet_xfwd [HTTP::header X-Forwarded-For]
  set packet_xfwd_len [string length $packet_xfwd]
  if { $packet_xfwd_len > 0 } {
     set xfwd [HTTP::header X-Forwarded-For]
  }  
  #----------------BEGIN pools--------------#
  set vip_name_1 "esbdev.genpt.net"
  set pool_port_1 "_pool_9222"
  set pool_port_2 "_pool_9242"
  set pool_port_3 "_pool_9262"
  set pool_port_4 "_pool_9282"
  set pool_port_5 "_pool_9302"
  set pool_port_6 "_pool_9322"
  set pool_port_7 "_pool_9342"
  set pool_port_8 "_pool_9362"
  set pool_port_9 "_pool_9382"
  set pool_port_10 "_pool_9402"
  set pool_port_11 "_pool_9422"
  set pool_1 $vip_name_1$pool_port_1
  set pool_2 $vip_name_1$pool_port_2
  set pool_3 $vip_name_1$pool_port_3
  set pool_4 $vip_name_1$pool_port_4
  set pool_5 $vip_name_1$pool_port_5
  set pool_6 $vip_name_1$pool_port_6
  set pool_7 $vip_name_1$pool_port_7
  set pool_8 $vip_name_1$pool_port_8
  set pool_9 $vip_name_1$pool_port_9
  set pool_10 $vip_name_1$pool_port_10
  set pool_11 $vip_name_1$pool_port_11
  set LogString1 "VIP:[virtual name], HTTP_REQUEST, UUID:$uuid, Client IP:[IP::client_addr], Real Client IP $xfwd:[TCP::client_port], Requested URL [HTTP::host][HTTP::uri], Pool "
  # Matches in each section below should be in Alphabetical order
  # to facilitate a structure/be identical from environment to environment
  switch -glob [string tolower [HTTP::uri]] {
    "/addshiptoaddress*" - 
    "/associateusertoaccount*" - 
    "/aswaconfig*" - 
    "/channels/inbound/order/http/createsalesorder*" - 
    "/checkstorenumber*" - 
    "/checkstorenumber/v2*" - 
    "/checkstorenumber_v2*" - 
    "/createcontactperson*" - 
    "/createcustomer*" - 
    "/deletestoreip*" - 
    "/directpartissue/directpartissueservice*" - 
    "/entity/subscription/{application}/{subscription_filter_name}*" - 
    "/eplanogram*" - 
    "/getbillinglist*" - 
    "/getbillingpdf*" - 
    "/getdeliverylist*" - 
    "/getorderlist*" - 
    "/getorderpdf*" - 
    "/getpricing*" - 
    "/getquotelist*" - 
    "/getstoredata/*" - 
    "/getstoreinfo*" - 
    "/insertstoreip*" - 
    "/inventorylookup*" - 
    "/lookupstoreip*" - 
    "/ordersubmit*" - 
    "/ordersubmit_v2*" - 
    "/parttransfer/parttransferservice*" - 
    "/prolinkregistration*" - 
    "/receiveinvoicefeed*" - 
    "/rest/validateaddress*" - 
    "/storeipservices*" - 
    "/subscription/{application}/filter/{subscription_filter_name}*" - 
    "/updatecontactperson*" - 
    "/updateshiptoaddress*" - 
    "/updatestoreip*" - 
    "/validateaccount*" - 
    "/validateaddress*" { 
      # If any of the above is in the URI use the below pool
      pool $pool_1
      set mypool $pool_1
      set LogString "$LogString1 $mypool"
    }
    "/activantaconnex/activantaconnexservice*" - 
    "/aggregateinvoiceinquiry*" - 
    "/b2binvoiceinquiry*" - 
    "/b2binvoiceinquirydetails*" - 
    "/cepdibilling*" - 
    "/cfa_posreconciliation/cfaposreconciliationservice*" - 
    "/ibiz_posreconciliation*" - 
    "/lucity/pos/lucityposservice*" - 
    "/oakridgeposreconciliation/posreconciliationservice*" - 
    "/partissue/partissueservice*" - 
    "/partupdaterequest/partupdaterequestservice*" - 
    "/posreconciliation/posreconciliationservice*" - 
    "/postransaction/postransactionservice*" - 
    "/sanimax/pos/sanimaxposservice*" - 
    "/sc_posdata/scposdataservice*" - 
    "/southwestposreconciliation/posreconciliationservice*" - 
    "/stjohnposreconciliation/stjohnposdataservice*" - 
    "/storeinvoicelkp*" - 
    "/xeroxposreconciliation/posreconciliationservice*" { 
      # If any of the above is in the URI use the below pool
      pool $pool_2
      set mypool $pool_2
      set LogString "$LogString1 $mypool"
    }
    "/loyalty-claimpoints*" - 
    "/loyalty-locationstatus*" - 
    "/loyalty-memberactivity*" - 
    "/loyalty-memberstatus*" - 
    "/loyalty-memberstatus/v2*" - 
    "/loyalty-pendingreward*" - 
    "/loyalty-registration*" - 
    "/loyalty-registration/v2*" - 
    "/loyalty-transactions*" - 
    "/tams-loyalty-memberstatus*" - 
    "/tams-loyalty-registration*" - 
    "/tams-loyalty-transactions*" - 
    "/v1/tokenization/custtokenlookup*" - 
    "/v1/tokenmanagement*" - 
    "/v2/tokenmanagement*" { 
      # If any of the above is in the URI use the below pool
      pool $pool_3
      set mypool $pool_3
      set LogString "$LogString1 $mypool"
    }
    "/dcinventory*" - 
    "/dcinventorysync*" - 
    "/dcsyncstatus*" - 
    "/deliveryexception*" - 
    "/getproductavailability*" - 
    "/getshuttlefeed*" - 
    "/getsiterelationship*" - 
    "/inventorysync*" - 
    "/inventorysyncstatus*" - 
    "/inventorysynctrigger*" - 
    "/rpminventorysyncstatus*" - 
    "/rpminventoryverification*" - 
    "/sdgdelete*" - 
    "/sitedelivery*" - 
    "/sitedeliveryfeed*" - 
    "/sitefeed*" - 
    "/siteleadtimes*" - 
    "/siterelationship*" - 
    "/sitetositedeliveryfeed*" - 
    "/storeconsolefeed*" - 
    "/storeinventory*" - 
    "/supplierinventory*" - 
    "/supplierinventoryrefresh*" { 
      # If any of the above is in the URI use the below pool
      pool $pool_4
      set mypool $pool_4
      set LogString "$LogString1 $mypool"
    }
    "/asn*" - 
    "/cart*" - 
    "/fesorder*" - 
    "/getcustomerprofile*" - 
    "/getdccost*" - 
    "/getshippingquote*" - 
    "/getuomconversion*" - 
    "/invoice*" - 
    "/optimizecart*" - 
    "/order*" - 
    "/receivenotification*" - 
    "/replenishmentorder*" - 
    "/requestforquote*" - 
    "/retrieveorder*" - 
    "/submitorder*" { 
      # If any of the above is in the URI use the below pool
      pool $pool_5
      set mypool $pool_5
      set LogString "$LogString1 $mypool"
    }
    "/asyncorder*" - 
    "/cancelorder*" - 
    "/cardpayment*" - 
    "/ejoei-orderstatus*" - 
    "/ijoei-jdemultipartinq*" - 
    "/inventoryverification*" - 
    "/inventoryverification/v3*" - 
    "/nol-b2bpartinq*" - 
    "/nol-b2bsalesorder*" - 
    "/nol-ca-b2bpartinq*" - 
    "/nol-ca-b2bsalesorder*" - 
    "/nol-salesorder*" - 
    "/nxporderstatusnotification*" - 
    "/partsaggbysiterelationship/v3*" - 
    "/partsavailabilitydetails/v3*" - 
    "/partsavailabilityfreepaid/v3*" - 
    "/returnnotification*" - 
    "/v1/partsaggbysiterelationship*" - 
    "/v1/partsavailabilitydetails*" - 
    "/v2/inventoryverification*" - 
    "/v2/partsaggbysiterelationship*" - 
    "/v2/partsavailabilitydetails*" - 
    "/v2/partsavailabilityfreepaid*" - 
    "/validatepayment*" { 
      # If any of the above is in the URI use the below pool
      pool $pool_6
      set mypool $pool_6
      set LogString "$LogString1 $mypool"
    }
    "/b2border*" - 
    "/esbaswarouter*" - 
    "/esbbridgerouter*" - 
    "/esbprolinkrouter*" - 
    "/esbsecurebridgerouter*" - 
    "/partpriceavailability*" { 
      # If any of the above is in the URI use the below pool
      pool $pool_7
      set mypool $pool_7
      set LogString "$LogString1 $mypool"
    }
    "/aswab2border*" - 
    "/aswab2bquery*" - 
    "/esbfindituaprouter*" - 
    "/esbisscrouter*" - 
    "/esbmultistoregaterouter*" - 
    "/findit*" - 
    "/isscorder*" - 
    "/isscquery/v1*" - 
    "/multistoreb2border*" - 
    "/multistorepartpriceavailability*" { 
      # If any of the above is in the URI use the below pool
      pool $pool_8
      set mypool $pool_8
      set LogString "$LogString1 $mypool"
    }
    "/deliverystatus*" - 
    "/receiveorderfeed*" { 
      # If any of the above is in the URI use the below pool
      pool $pool_9
      set mypool $pool_9
      set LogString "$LogString1 $mypool"
    }
    "/fms-b2bpartorder*" - 
    "/getnewibsstores*" - 
    "/inventorylinefeed*" - 
    "/inventorypartdetail*" - 
    "/inventorystocklocation*" - 
    "/portalnotify*" - 
    "/workorderservice/workorderrequest*" { 
      # If any of the above is in the URI use the below pool
      pool $pool_10
      set mypool $pool_10
      set LogString "$LogString1 $mypool"
    }
    "/micorservice/micorservice*" - 
    "/rpm/pulse/orderstatusnotification/v1*" { 
      # If any of the above is in the URI use the below pool
      pool $pool_11
      set mypool $pool_11
      set LogString "$LogString1 $mypool"
    }
  }
  #----------------END pools----------------#
}
when LB_SELECTED {
      # Create Variable to Log Pool Member Chosen
      set LogString2 "to Pool Mbr [LB::server addr]"
      # Log Client IP, URL, and Pool Member Chosen
      log local0. "$LogString $LogString2"
}
when HTTP_RESPONSE {
  set uuid "None"
  set packet_uuid [HTTP::header values uniqueid]
  set packet_uuid_len [string length $packet_uuid]
  if { $packet_uuid_len > 0 } {
     set uuid [HTTP::header values uniqueid]
  }
  log local0. "VIP:[virtual name], HTTP_RESPONSE, UUID:$uuid, HTTP Code:[HTTP::status], Pool Member:[LB::server addr] Client IP:[IP::client_addr]:[TCP::client_port]"
}