# ESB iRule to set correct pool based on URI
# https://devcentral.f5.com/articles/irules-101-04-switch
#
when HTTP_REQUEST { 
  set uuid "None"
  set packet_uuid [HTTP::header values uniqueid]
  set packet_uuid_len [string length $packet_uuid]
  if { $packet_uuid_len > 0 } {
     set uuid [HTTP::header values uniqueid]
  }
  set xfwd [IP::client_addr]
  set packet_xfwd [HTTP::header X-Forwarded-For]
  set packet_xfwd_len [string length $packet_xfwd]
  if { $packet_xfwd_len > 0 } {
     set xfwd [HTTP::header X-Forwarded-For]
  }  
  #----------------BEGIN pools--------------#
  set vip_name_1 "esb.genpt.net"
  set pool_port_0 "_pool_9202"
  set pool_port_1 "_pool_9222"
  set pool_port_2 "_pool_9242"
  set pool_port_3 "_pool_9262"
  set pool_port_4 "_pool_9282"
  set pool_port_5 "_pool_9302"
  set pool_port_6 "_pool_9322"
  set pool_port_7 "_pool_9342"
  set pool_port_8 "_pool_9362"
  set pool_port_9 "_pool_9382"
  set pool_port_10 "_pool_9402"
  set pool_port_11 "_pool_9422"
  set pool_port_12 "_pool_9442"
  set pool_port_13 "_pool_9462"
  set pool_port_14 "_pool_9482"
  set pool_0 $vip_name_1$pool_port_0
  set pool_1 $vip_name_1$pool_port_1
  set pool_2 $vip_name_1$pool_port_2
  set pool_3 $vip_name_1$pool_port_3
  set pool_4 $vip_name_1$pool_port_4
  set pool_5 $vip_name_1$pool_port_5
  set pool_6 $vip_name_1$pool_port_6
  set pool_7 $vip_name_1$pool_port_7
  set pool_8 $vip_name_1$pool_port_8
  set pool_9 $vip_name_1$pool_port_9
  set pool_10 $vip_name_1$pool_port_10
  set pool_11 $vip_name_1$pool_port_11
  set pool_12 $vip_name_1$pool_port_12
  set pool_13 $vip_name_1$pool_port_13
  set pool_14 $vip_name_1$pool_port_14
  set LogString1 "VIP:[virtual name], HTTP_REQUEST, UUID:$uuid, Client IP:[IP::client_addr], Real Client IP $xfwd:[TCP::client_port], Requested URL [HTTP::host][HTTP::uri], Pool "
  # Matches in each section below should be in Alphabetical order
  # to facilitate a structure/be identical from environment to environment
  switch -glob [string tolower [HTTP::uri]] {
    "/ping0" { 
      if {[string tolower [HTTP::uri]] == "ping0" } {
        HTTP::uri "ping"
      }
      # If any of the above is in the URI use the below pool
      pool $pool_0
      set mypool $pool_0
      set LogString "$LogString1 $mypool"
    }
    "/accountstatus/*" - 
    "/aswaconfig*" - 
    "/channels/inbound/invoice/http/invoicevalidation*" - 
    "/channels/inbound/order/http/createsalesorder*" - 
    "/checkstorenumber*" - 
    "/checkstorenumber/v2*" - 
    "/checkstorenumber_v2*" - 
    "/customer/registration/v1*" - 
    "/deletestoreip*" - 
    "/directpartissue/directpartissueservice*" - 
    "/entity/subscription/*" - 
    "/eplanogram*" - 
    "/getsiteattributes*" - 
    "/getstoredata/*" - 
    "/getstoreinfo*" - 
    "/insertstoreip*" - 
    "/invoice/inquiry/v1*" - 
    "/invoiceinquiry*" - 
    "/locateproductwhi/*" - 
    "/locations/v1*" - 
    "/lookupstoreip*" - 
    "/nsight/site/aliasname/{aliasname}/aliasvalue/{aliasvalue}*" - 
    "/orderwhi/*" - 
    "/parttransfer/parttransferservice*" - 
    "/ping1" - 
    "/prolinkregistration*" - 
    "/rest/validateaddress*" - 
    "/subscription/*" - 
    "/updatestoreip*" - 
    "/v1/invoicevalidate*" - 
    "/validateaddress*" { 
      if {[string tolower [HTTP::uri]] == "ping1" } {
        HTTP::uri "ping"
      }
      # If any of the above is in the URI use the below pool
      pool $pool_1
      set mypool $pool_1
      set LogString "$LogString1 $mypool"
    }
    "/activantaconnex/activantaconnexservice*" - 
    "/b2binvoiceinquiry*" - 
    "/b2binvoiceinquirydetails*" - 
    "/cepdibilling*" - 
    "/cfa_posreconciliation/cfaposreconciliationservice*" - 
    "/lucity/pos/lucityposservice*" - 
    "/oakridgeposreconciliation/posreconciliationservice*" - 
    "/partissue/partissueservice*" - 
    "/partupdaterequest/partupdaterequestservice*" - 
    "/ping2" - 
    "/posreconciliation/posreconciliationservice*" - 
    "/postransaction/postransactionservice*" - 
    "/sanimax/pos/sanimaxposservice*" - 
    "/sc_posdata/scposdataservice*" - 
    "/southwestposreconciliation/posreconciliationservice*" - 
    "/stjohnposreconciliation/stjohnposdataservice*" - 
    "/storeinvoicelkp*" - 
    "/xeroxposreconciliation/posreconciliationservice*" { 
      if {[string tolower [HTTP::uri]] == "ping2" } {
        HTTP::uri "ping"
      }
      # If any of the above is in the URI use the below pool
      pool $pool_2
      set mypool $pool_2
      set LogString "$LogString1 $mypool"
    }
    "/loyalty-claimpoints*" - 
    "/loyalty-locationstatus*" - 
    "/loyalty-memberactivity*" - 
    "/loyalty-memberstatus*" - 
    "/loyalty-memberstatus/v2*" - 
    "/loyalty-pendingreward*" - 
    "/loyalty-registration*" - 
    "/loyalty-registration/v2*" - 
    "/loyalty-transactions*" - 
    "/ping3" - 
    "/tams-loyalty-memberstatus*" - 
    "/tams-loyalty-registration*" - 
    "/tams-loyalty-transactions*" - 
    "/v1/tokenization/custtokenlookup*" - 
    "/v1/tokenmanagement*" { 
      if {[string tolower [HTTP::uri]] == "ping3" } {
        HTTP::uri "ping"
      }
      # If any of the above is in the URI use the below pool
      pool $pool_3
      set mypool $pool_3
      set LogString "$LogString1 $mypool"
    }
    "/barcode/lookup*" - 
    "/barcode/scan*" - 
    "/dcinventory*" - 
    "/dcinventorysync*" - 
    "/dcsyncstatus*" - 
    "/getproductavailability*" - 
    "/getsiterelationship*" - 
    "/inventorysync*" - 
    "/inventorysyncstatus*" - 
    "/inventorysynctrigger*" - 
    "/ping4" - 
    "/sdgdelete*" - 
    "/shipment/getpathdetails*" - 
    "/sitedelivery*" - 
    "/sitefeed*" - 
    "/siteleadtimes*" - 
    "/siterelationship*" - 
    "/storeinventory*" - 
    "/supplierinventory*" - 
    "/supplierinventoryrefresh*" - 
    "/updatesitedisplay*" { 
      if {[string tolower [HTTP::uri]] == "ping4" } {
        HTTP::uri "ping"
      }
      # If any of the above is in the URI use the below pool
      pool $pool_4
      set mypool $pool_4
      set LogString "$LogString1 $mypool"
    }
    "/asn*" - 
    "/asnasync*" - 
    "/cartservice*" - 
    "/fesorder*" - 
    "/getcustomerprofile*" - 
    "/getdccost*" - 
    "/getshippingquote*" - 
    "/getuomconversion*" - 
    "/invoice*" - 
    "/optimizecart*" - 
    "/order*" - 
    "/ping5" - 
    "/receivenotification*" - 
    "/replenishmentorder*" - 
    "/requestforquote*" - 
    "/retrieveorder*" - 
    "/storeprice*" - 
    "/submitorder*" { 
      if {[string tolower [HTTP::uri]] == "ping5" } {
        HTTP::uri "ping"
      }
      # If any of the above is in the URI use the below pool
      pool $pool_5
      set mypool $pool_5
      set LogString "$LogString1 $mypool"
    }
    "/asyncorder*" - 
    "/cancelorder*" - 
    "/cardpayment*" - 
    "/ejoei-orderstatus*" - 
    "/ijoei-jdemultipartinq*" - 
    "/inventoryverification*" - 
    "/inventoryverification/v3*" - 
    "/locateproduct*" - 
    "/locateproduct/v2*" - 
    "/locateproduct/v3*" - 
    "/locateproduct/v4*" - 
    "/nol-b2bpartinq*" - 
    "/nol-b2bsalesorder*" - 
    "/nol-ca-b2bpartinq*" - 
    "/nol-ca-b2bsalesorder*" - 
    "/nol-salesorder*" - 
    "/nxporderstatusnotification*" - 
    "/partsaggbysiterelationship/v3*" - 
    "/partsavailabilitydetails/v3*" - 
    "/ping6" - 
    "/returnnotification*" - 
    "/returnorder*" - 
    "/v1/partsavailabilitydetails*" - 
    "/v2/inventoryverification*" - 
    "/v2/partsavailabilitydetails*" - 
    "/validatepayment*" { 
      if {[string tolower [HTTP::uri]] == "ping6" } {
        HTTP::uri "ping"
      }
      # If any of the above is in the URI use the below pool
      pool $pool_6
      set mypool $pool_6
      set LogString "$LogString1 $mypool"
    }
    "/b2border*" - 
    "/esbaswarouter*" - 
    "/esbbridgerouter*" - 
    "/esbprolinkrouter*" - 
    "/esbsecurebridgerouter*" - 
    "/partpriceavailability*" - 
    "/ping7" { 
      if {[string tolower [HTTP::uri]] == "ping7" } {
        HTTP::uri "ping"
      }
      # If any of the above is in the URI use the below pool
      pool $pool_7
      set mypool $pool_7
      set LogString "$LogString1 $mypool"
    }
    "/aswab2border*" - 
    "/aswab2bquery*" - 
    "/esbfindituaprouter*" - 
    "/esbisscrouter*" - 
    "/esbmultistoregaterouter*" - 
    "/findit*" - 
    "/isscorder*" - 
    "/isscquery/v1*" - 
    "/multistoreb2border*" - 
    "/multistorepartpriceavailability*" - 
    "/ping8" { 
      if {[string tolower [HTTP::uri]] == "ping8" } {
        HTTP::uri "ping"
      }
      # If any of the above is in the URI use the below pool
      pool $pool_8
      set mypool $pool_8
      set LogString "$LogString1 $mypool"
    }
    "/deliverystatus*" - 
    "/ping9" - 
    "/receiveorderfeed*" { 
      if {[string tolower [HTTP::uri]] == "ping9" } {
        HTTP::uri "ping"
      }
      # If any of the above is in the URI use the below pool
      pool $pool_9
      set mypool $pool_9
      set LogString "$LogString1 $mypool"
    }
    "/fms-b2bpartorder*" - 
    "/getnewibsstores*" - 
    "/inventorylinefeed*" - 
    "/inventorypartdetail*" - 
    "/inventorystocklocation*" - 
    "/ping10" - 
    "/portalnotify*" - 
    "/workorderservice/workorderrequest*" { 
      if {[string tolower [HTTP::uri]] == "ping10" } {
        HTTP::uri "ping"
      }
      # If any of the above is in the URI use the below pool
      pool $pool_10
      set mypool $pool_10
      set LogString "$LogString1 $mypool"
    }
    "/micorservice/micorservice*" - 
    "/ping11" - 
    "/rpm/pulse/orderstatusnotification/v1*" { 
      if {[string tolower [HTTP::uri]] == "ping11" } {
        HTTP::uri "ping"
      }
      # If any of the above is in the URI use the below pool
      pool $pool_11
      set mypool $pool_11
      set LogString "$LogString1 $mypool"
    }
    "/esb/cle/replayconfig/management/v1*" - 
    "/esb/nsight/config/management/v1*" - 
    "/ping12" - 
    "/triggerssh*" - 
    "/updatenotes*" { 
      if {[string tolower [HTTP::uri]] == "ping12" } {
        HTTP::uri "ping"
      }
      # If any of the above is in the URI use the below pool
      pool $pool_12
      set mypool $pool_12
      set LogString "$LogString1 $mypool"
    }
    "/ping13" - 
    "/receiveinvoicefeed*" { 
      if {[string tolower [HTTP::uri]] == "ping13" } {
        HTTP::uri "ping"
      }
      # If any of the above is in the URI use the below pool
      pool $pool_13
      set mypool $pool_13
      set LogString "$LogString1 $mypool"
    }
    "/partsavailabilityfreepaid/v3*" - 
    "/partsavailabilityfreepaid/v4*" - 
    "/partsavailabilityfreepaidagg/v4*" - 
    "/partsavailabilityfreepaidaggnol/v4*" - 
    "/partsavailabilityfreepaidaggnol/v4/1*" - 
    "/partsavailabilityfreepaidaggnol/v4/2*" - 
    "/ping14" { 
      if {[string tolower [HTTP::uri]] == "ping14" } {
        HTTP::uri "ping"
      }
      # If any of the above is in the URI use the below pool
      pool $pool_14
      set mypool $pool_14
      set LogString "$LogString1 $mypool"
    }
  }
  #----------------END-pools----------------#
}
when LB_SELECTED {
      # Create Variable to Log Pool Member Chosen
      set LogString2 "to Pool Mbr [LB::server addr]"
      # Log Client IP, URL, and Pool Member Chosen
      log local0. "$LogString $LogString2"
}
when HTTP_RESPONSE {
  set uuid "None"
  set packet_uuid [HTTP::header values uniqueid]
  set packet_uuid_len [string length $packet_uuid]
  if { $packet_uuid_len > 0 } {
     set uuid [HTTP::header values uniqueid]
  }
  log local0. "VIP:[virtual name], HTTP_RESPONSE, UUID:$uuid, HTTP Code:[HTTP::status], Pool Member:[LB::server addr] Client IP:[IP::client_addr]:[TCP::client_port]"
}