# ESB iRule to set correct pool based on URI
# https://devcentral.f5.com/articles/irules-101-04-switch
#
when HTTP_REQUEST {
  set uuid "None"
  set packet_uuid [HTTP::header values uniqueid]
  set packet_uuid_len [string length $packet_uuid]
  if { $packet_uuid_len > 0 } {
     set uuid [HTTP::header values uniqueid]
  }
  set xfwd [IP::client_addr]
  set packet_sfwd [HTTP::header X-Forwarded-For]
  set packet_sfwd_len [string length $packet_sfwd]
  if { $packet_sfwd_len > 0 } {
     set xfwd [HTTP::header X-Forwarded-For]
  }
  switch -glob [string tolower [HTTP::uri]] {
    "/*" {
    # If any of the above is in the URI use the below pool
      pool "esbuat.genpt.com_pool_8081"
      set mypool "esbuat.genpt.com_pool_8081"
      set LogString "VIP:[virtual name] Real Client IP [HTTP::header X-Forwarded-For]:[TCP::client_port] Requested URL [HTTP::host][HTTP::uri] Pool $mypool"
    }
  }
}
when LB_SELECTED {
      # Create Variable to Log Pool Member Chosen
      set LogString2 "to Pool Mbr [LB::server addr]"
      # Log Client IP, URL, and Pool Member Chosen
      log local0. "$LogString $LogString2"
}
when HTTP_RESPONSE {
  set uuid "None"
  set packet_uuid [HTTP::header values uniqueid]
  set packet_uuid_len [string length $packet_uuid]
  if { $packet_uuid_len > 0 } {
     set uuid [HTTP::header values uniqueid]
  }
  log local0. "VIP:[virtual name], HTTP_RESPONSE, UUID:$uuid, HTTP Code:[HTTP::status], Pool Member:[LB::server addr] Client IP:[IP::client_addr]:[TCP::client_port]"
}
